## libgridxc 2.0.1

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.14)

list(APPEND
   CMAKE_MODULE_PATH
   ${CMAKE_CURRENT_SOURCE_DIR}/config/cmake
  )

include(utils)
ensure_out_of_source_build()

project(
  "libgridxc"
  LANGUAGES "Fortran"
  VERSION "2.0.1"
  DESCRIPTION "Library for XC computation on grids"
)

# Follow GNU conventions for installing directories
include(GNUInstallDirs)

# Avoid 'liblibgridxc' installed library names
set(LIBRARY_OUTPUT_NAME "gridxc")

# General configuration information
add_subdirectory("config")

# Compiler flags
include(flags)

option(WITH_MPI "Whether libgridxc should support MPI-parallelism" FALSE)
option(WITH_LIBXC "Whether libgridxc has a libxc interface" FALSE)
option(WITH_GRID_SP "Whether libgridxc has a single-precision (cellxc only) interface" FALSE)

if(WITH_MPI)
  if (NOT TARGET MPI::MPI_Fortran)
    find_package(MPI REQUIRED)
  endif()
endif()

# Collect source of the project
set(srcs)
add_subdirectory("src")

add_library(
  "${PROJECT_NAME}-lib"
  "${srcs}"
)

#-------------
#  This is a record of a feature that can be checked programmatically when
#  configuring clients if libgridxc is used as a pre-compiled library, but
#  not if the libgridxc source is compiled by the client.
#
set(LIBGRIDXC_HAS_PROCEDURE_POINTERS TRUE CACHE BOOL "libgridxc uses procedure pointers")
#-------------

set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "${LIBRARY_OUTPUT_NAME}"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include"
)

if(WITH_LIBXC)

 if (NOT TARGET Libxc::xc_Fortran)
  find_package(CustomLibxc)
  if (TARGET Libxc::xc_Fortran)
    message(VERBOSE "Defining new target libxc::XC_Fortran...")
    add_library(libxc::XC_Fortran INTERFACE IMPORTED)
    target_link_libraries(libxc::XC_Fortran INTERFACE Libxc::xc_Fortran)
  endif()
 endif()

 if(NOT LIBXC_Fortran_FOUND)
   message(WARNING
    "Libxc support has been requested ${WITH_LIBXC} : ${LIBXC_Fortran_FOUND}, but the fortran libxc library cannot be\
 found.")
   message(FATAL_ERROR "Libxc could not be found by CMake")
 endif()

  target_compile_definitions(
  ${PROJECT_NAME}-lib
  PRIVATE
  HAVE_LIBXC
  )

  target_link_libraries(
    "${PROJECT_NAME}-lib"
    PUBLIC
    libxc::XC_Fortran
  )
endif()

if(WITH_GRID_SP)
  target_compile_definitions(
  ${PROJECT_NAME}-lib
  PUBLIC
  GRID_SP
  )
endif()


if(WITH_MPI)
  target_compile_definitions(
  "${PROJECT_NAME}-lib"
  PRIVATE HAVE_MPI
  )

  target_link_libraries("${PROJECT_NAME}-lib" PUBLIC MPI::MPI_Fortran)

endif()

target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)

# Export targets for other projects
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")
install(
  TARGETS
  "${PROJECT_NAME}"
  "${PROJECT_NAME}-lib"
  EXPORT
  "${PROJECT_NAME}-targets"
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
)
install(
  EXPORT
  "${PROJECT_NAME}-targets"
  NAMESPACE
  "${PROJECT_NAME}::"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(
  DIRECTORY
  "${CMAKE_CURRENT_BINARY_DIR}/include/"
  DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
)
# Package license files
install(
  FILES
  "COPYING"
  DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
)

add_subdirectory("docs")

# add the testsuite

enable_testing()
add_subdirectory("Testers")

=== Testers/CMakeLists.txt ===
message(STATUS "Configuring libgridxc tests...")

#
# Note that the tests will only be built when this target is
# requested if the tests targets are marked "EXCLUDE_FROM_ALL".
# This mechanism is handy for individual libraries, but does
# not permit selective testing when they are subprojects of
# a larger module. The scheme is deactivated for now (lines
# with '### ' prefix).
#
# When activated, one would use, for example:
#
#    cmake --build _build -- libgridxc-tests
#    cmake --build _build -- test
#
# to build and run the tests.
#

### add_custom_target("${PROJECT_NAME}-tests")

include(TestMPIConfig)

macro(define_test
      name
      source
      mpi_enabled
      )

 message(DEBUG " --> Add libgridxc_${name} test")
 
 add_executable(
  "${PROJECT_NAME}-${name}"
  ### Deactivate the scheme for now
  ### EXCLUDE_FROM_ALL
  "${source}"
 )
### add_dependencies("${PROJECT_NAME}-tests"   "${PROJECT_NAME}-${name}")

 target_link_libraries(
  "${PROJECT_NAME}-${name}"
  PRIVATE
  "${PROJECT_NAME}-lib"
 )

 if(WITH_MPI)
    target_compile_definitions(
      "${PROJECT_NAME}-${name}"
      PRIVATE
      HAVE_MPI
    )
  target_link_libraries("${PROJECT_NAME}-${name}" PRIVATE MPI::MPI_Fortran)

 endif()
 
 if(WITH_LIBXC)
    target_compile_definitions(
      "${PROJECT_NAME}-${name}"
      PRIVATE
      HAVE_LIBXC
    )
    target_link_libraries(
      "${PROJECT_NAME}-${name}"
      PRIVATE
      libxc::XC_Fortran
    )
  endif()

  if (${mpi_enabled} AND WITH_MPI)
    separate_arguments(MPIEXEC_PREFLAGS)
    add_test( NAME "libgridxc_mpi_${name}"
              COMMAND
                ${MPIEXEC_EXECUTABLE}
                ${MPIEXEC_NUMPROC_FLAG} "${num_ranks}"
                ${MPIEXEC_PREFLAGS}
		$<TARGET_FILE:${PROJECT_NAME}-${name}> ${MPIEXEC_POSTFLAGS})

  else()
  
    add_test(NAME "libgridxc_${name}" COMMAND $<TARGET_FILE:${PROJECT_NAME}-${name}> )
    
  endif()
  
endmacro()

define_test(test1 test1.f90 OFF)
define_test(test2 test2.F90 ON)
define_test(test3 test3.F90 ON)
define_test(test4 test4.F90 ON)
# test5 is pending refactoring
define_test(test6 test6.f90 OFF)
      
if (WITH_LIBXC)
  define_test(test_libxc test_libxc.F90 ON)
  define_test(test_libxc2 test_libxc2.F90 ON)
  define_test(test_match test_match.F90 OFF)
  define_test(test_hse06 test_hse06.F90 OFF)
endif()

=== docs/CMakeLists.txt ===
#
# Logic taken from SIRIUS distribution
#
# FORD version of the documentation
#
# Some modern versions of FORD are unable to process correctly the
# inter-page links. Treat this as work-in-progress
#
message(STATUS "Configuring docs")
find_program(FORD_EXE ford
  ENV FORD_PROGRAM
  DOC "path to the ford executable (required to generate the documentation)"
  )
  
if(FORD_EXE AND LIBGRIDXC_BUILD_DOCS_FORD)

  # for ford pre-processing
  if(WITH_LIBXC)
    set(INCLUDE_LIBXC "HAVE_LIBXC")
  else()
    set(INCLUDE_LIBXC "_DUMMY")
  endif()
 # Copy the FORD project-file into the build directory
 set (FORD_PROJECT_FILE "${CMAKE_CURRENT_BINARY_DIR}/ford.md")
 set(FORD_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/doc-ford-build")
 configure_file(ford.cfg.in "${FORD_PROJECT_FILE}" @ONLY)

 message(STATUS "Done generating ford.md")

 add_custom_target(doc-ford ALL
  COMMENT "Generating FORD API documentation"
  COMMAND "${FORD_EXE}" "${FORD_PROJECT_FILE}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  VERBATIM
  )
 message(STATUS "Done generating documentation")
 
  install(DIRECTORY "${FORD_OUTPUT_DIR}/" DESTINATION ${CMAKE_INSTALL_PREFIX}/doc)
endif()

=== debian/changelog ===
libgridxc (2.0.1-1) unstable; urgency=medium

  * New upstream point release.

 -- Michael Banck <mbanck@debian.org>  Fri, 29 Dec 2023 19:51:33 +0100

libgridxc (2.0.0-1) unstable; urgency=medium

  * Initial release.

 -- Michael Banck <mbanck@debian.org>  Sun, 01 Oct 2023 18:31:42 +0200

=== debian/control ===
Source: libgridxc
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               gfortran,
               libxc-dev,
               pkg-config
Standards-Version: 4.1.3
Homepage: https://gitlab.com/siesta-project/libraries/libgridxc
Vcs-Browser: https://salsa.debian.org/debichem-team/libgridxc
Vcs-Git: https://salsa.debian.org/debichem-team/ibgridxc.git

Package: libgridxc-dev
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Library to compute exchange/correlation energies (development files)
 libGridXC is a library for the computation of exchange and correlation
 energies and potentials in radial and 3D grids.
 .
 This package contains the static libraries and the header files.

=== debian/watch ===
version=4
  https://gitlab.com/siesta-project/libraries/libgridxc/tags?sort=updated_desc archive/v?\d[\d.]+/libgridxc-v?([\d.]+)@ARCHIVE_EXT@

## libgridxc 2.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 project(
   "libgridxc"
   LANGUAGES "Fortran"
-  VERSION "2.0.1"
+  VERSION "2.0.2"
   DESCRIPTION "Library for XC computation on grids"
 )

=== config/CMakeLists.txt ===

option(BUILD_SHARED_LIBS "Whether the libraries built should be shared" FALSE)

if(NOT DEFINED "${PROJECT_NAME}-dependency-method")
  set(
    "${PROJECT_NAME}-dependency-method"
    "cmake" "pkgconf" "subproject" "fetch"
  )
endif()

set(
  module-dir
  "${PROJECT_NAME}/${CMAKE_Fortran_COMPILER_ID}-${CMAKE_Fortran_COMPILER_VERSION}"
)
set(module-dir "${module-dir}" PARENT_SCOPE)


# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

include(CMakePackageConfigHelpers)

configure_package_config_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

# Use "AnyNewerVersion" but recommend checking for new features
# (i.e. procedure pointers) at client's configuration time.
# In this way we can request, say, a minimum version of 1.1.0, and
# still be able to use 2.X if found.

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  VERSION "${PROJECT_VERSION}"
  COMPATIBILITY AnyNewerVersion
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/template.pkgconf"
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)
install(
  FILES
  "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
)

=== src/CMakeLists.txt ===
set(dir "${CMAKE_CURRENT_SOURCE_DIR}")

list(
  APPEND srcs

  "${dir}/alloc.F90"
  "${dir}/am05.F90"
  "${dir}/array.F90"
  "${dir}/atomxc.F90"
  "${dir}/bessph.F90"
  "${dir}/cellsubs.F90"
  "${dir}/cellxc.F90"
  "${dir}/chkgmx.F90"
  "${dir}/debugxc.F90"
  "${dir}/fft3d.F90"
  "${dir}/fftr.F90"
  "${dir}/ggaxc.F90"
  "${dir}/gridxc.F90"
  "${dir}/gridxc_config.F90"
  "${dir}/gridxc_fft_gpfa.F90"
  "${dir}/interpolation.F90"
  "${dir}/ldaxc.F90"
  "${dir}/m_io.F90"
  "${dir}/m_walltime.F90"
  "${dir}/mesh1d.F90"
  "${dir}/mesh3d.F90"
  "${dir}/minvec.F90"
  "${dir}/moreParallelSubs.F90"
  "${dir}/precision.F90"
  "${dir}/radfft.F90"
  "${dir}/sorting.F90"
  "${dir}/sys.F90"
  "${dir}/vdwxc.F90"
  "${dir}/vv_vdwxc.F90"
  "${dir}/xc_hybrids.F90"
  "${dir}/xc_xwpbe.F90"
  "${dir}/xcmod.F90"

)

set(srcs "${srcs}" PARENT_SCOPE)

=== debian/changelog ===
libgridxc (2.0.2-1) unstable; urgency=medium

  * New upstream point release.
  * debian/watch: Updated. 
  * debian/control (Vcs-Git): Fixed git url. 

 -- Michael Banck <mbanck@debian.org>  Thu, 14 Nov 2024 20:38:48 +0100

## libgridxc 2.1.0

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.14)

list(APPEND
   CMAKE_MODULE_PATH
   ${CMAKE_CURRENT_SOURCE_DIR}/config/cmake
  )

include(utils)
ensure_out_of_source_build()

list(APPEND CMAKE_MESSAGE_CONTEXT "libgridxc")
project(
  libgridxc
  LANGUAGES Fortran
  VERSION "2.1.0"
  DESCRIPTION "Library for XC computation on grids"
)

# Follow GNU conventions for installing directories
include(GNUInstallDirs)


# Allow legacy names (e.g. WITH_LIBXC) for options
include(LibgridxcPrefixOptions)

#
option(LIBGRIDXC_WITH_MPI "Whether libgridxc should support MPI-parallelism" FALSE)
option(LIBGRIDXC_WITH_LIBXC "Whether libgridxc has a libxc interface" FALSE)
option(LIBGRIDXC_WITH_GRID_SP "Whether libgridxc has a single-precision (cellxc only) interface" FALSE)

option(LIBGRIDXC_BUILD_DOCS "Whether the libgridxc docs are built " FALSE)
option(LIBGRIDXC_TESTS "Whether the libgridxc tests are built " ${PROJECT_IS_TOP_LEVEL})
option(LIBGRIDXC_INSTALL "Whether to install the libgridxc binaries" TRUE)

# Allow this project to override the general setting
if(DEFINED LIBGRIDXC_SHARED_LIBS)
   set(BUILD_SHARED_LIBS ${LIBGRIDXC_SHARED_LIBS})
   message(STATUS "Setting BUILD_SHARED_LIBS to ${LIBGRIDXC_SHARED_LIBS}")
endif()

# General configuration information: Build_type, Config files...
add_subdirectory("config")

# Compiler flags
include(flags)

if(LIBGRIDXC_WITH_MPI)
  if (NOT TARGET MPI::MPI_Fortran)
    find_package(MPI REQUIRED)
  endif()
endif()

# Collect source of the project
set(srcs)
add_subdirectory("src")

add_library(
  "${PROJECT_NAME}-lib"
  "${srcs}"
)

#-------------
#  This is a record of a feature that can be checked programmatically when
#  configuring clients if libgridxc is used as a pre-compiled library, but
#  not if the libgridxc source is compiled by the client.
#
set(LIBGRIDXC_HAS_PROCEDURE_POINTERS TRUE CACHE BOOL "libgridxc uses procedure pointers")
#-------------

set_target_properties(
  "${PROJECT_NAME}-lib"
  PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  OUTPUT_NAME "gridxc"
  VERSION "${PROJECT_VERSION}"
  SOVERSION "${PROJECT_VERSION_MAJOR}"
  Fortran_MODULE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/include"
)
#
# It seems that CMake creates this directory at build time, but
# we might need it at configuration time in some cases (e.g when
# using FetchContent)
#
if(NOT EXISTS "${CMAKE_CURRENT_BINARY_DIR}/include")
  make_directory("${CMAKE_CURRENT_BINARY_DIR}/include")
endif()

if(LIBGRIDXC_WITH_LIBXC)

 if (NOT TARGET Libxc::xc_Fortran)
  find_package(CustomLibxc)
  if (TARGET Libxc::xc_Fortran)
    message(VERBOSE "Defining new target libxc::XC_Fortran...")
    add_library(libxc::XC_Fortran INTERFACE IMPORTED)
    target_link_libraries(libxc::XC_Fortran INTERFACE Libxc::xc_Fortran)
  endif()
 endif()

 if(NOT LIBXC_Fortran_FOUND)
   message(WARNING
    "Libxc support has been requested, but the fortran libxc library cannot be found.")
   message(FATAL_ERROR "Libxc could not be found by CMake")
 endif()

  target_compile_definitions(
  ${PROJECT_NAME}-lib
  PRIVATE
  HAVE_LIBXC
  )

  target_link_libraries(
    "${PROJECT_NAME}-lib"
    PUBLIC
    libxc::XC_Fortran
  )
endif()

if(LIBGRIDXC_WITH_GRID_SP)
  target_compile_definitions(
  ${PROJECT_NAME}-lib
  PUBLIC
  GRID_SP
  )
endif()


if(LIBGRIDXC_WITH_MPI)
  target_compile_definitions(
  "${PROJECT_NAME}-lib"
  PRIVATE HAVE_MPI
  )

  target_link_libraries("${PROJECT_NAME}-lib" PUBLIC MPI::MPI_Fortran)

endif()

set(
  module-dir
  "${PROJECT_NAME}/${CMAKE_Fortran_COMPILER_ID}-${CMAKE_Fortran_COMPILER_VERSION}"
)

target_include_directories(
  "${PROJECT_NAME}-lib"
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}>
)

#
# This auxiliary target is useful when we compile on the fly, and
# we employ the idiom
#
#     add_subdirectory("Path/to/libgridxc")
#     add_library(libgridxc::libgridxc ALIAS libgridxc)
#
# instead of using the imported target libgridxc::libgridxc as obtained,
# for example, with 'find_package'.
# 
#
add_library("${PROJECT_NAME}" INTERFACE)
target_link_libraries("${PROJECT_NAME}" INTERFACE "${PROJECT_NAME}-lib")

# For future uses, we might create an alias target here, to exploit
# the new feature of integration of 'FetchContent' and 'find_package'
# It is enabled by a variable since old clients might still have
# the aliasing statement hardwired after the FetchContent processing.

if (${LIBGRIDXC_CREATE_TARGET_ALIAS})
  add_library("${PROJECT_NAME}::${PROJECT_NAME}" ALIAS ${PROJECT_NAME})
endif()

if (LIBGRIDXC_INSTALL)
  # Export targets for other projects
  
  install(
    TARGETS
    "${PROJECT_NAME}"
    "${PROJECT_NAME}-lib"
    EXPORT
    "${PROJECT_NAME}-targets"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  )
  install(
    EXPORT
    "${PROJECT_NAME}-targets"
    NAMESPACE
    "${PROJECT_NAME}::"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )
  install(
    DIRECTORY
    "${CMAKE_CURRENT_BINARY_DIR}/include/"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${module-dir}"
  )
  # Package license files
  install(
    FILES
    "COPYING"
    DESTINATION "${CMAKE_INSTALL_DATADIR}/licenses/${PROJECT_NAME}"
  )

endif(LIBGRIDXC_INSTALL)

if(LIBGRIDXC_BUILD_DOCS)
  add_subdirectory("docs")
endif(LIBGRIDXC_BUILD_DOCS)

if(LIBGRIDXC_TESTS)
  # add the testsuite

  enable_testing()
  add_subdirectory("Testers")
  
endif(LIBGRIDXC_TESTS)

list(POP_BACK CMAKE_MESSAGE_CONTEXT)

=== Testers/CMakeLists.txt ===
message(STATUS "Configuring libgridxc tests...")

include(TestMPIConfig)

macro(define_test
      name
      source
      mpi_enabled
      )

 message(DEBUG " --> Add libgridxc_${name} test")
 
 add_executable(
  "${PROJECT_NAME}-${name}"
  "${source}"
 )

 target_link_libraries(
  "${PROJECT_NAME}-${name}"
  PRIVATE
  "${PROJECT_NAME}-lib"
 )

 if(LIBGRIDXC_WITH_MPI)
    target_compile_definitions(
      "${PROJECT_NAME}-${name}"
      PRIVATE
      HAVE_MPI
    )
  target_link_libraries("${PROJECT_NAME}-${name}" PRIVATE MPI::MPI_Fortran)

 endif()
 
 if(LIBGRIDXC_WITH_LIBXC)
    target_compile_definitions(
      "${PROJECT_NAME}-${name}"
      PRIVATE
      HAVE_LIBXC
    )
    target_link_libraries(
      "${PROJECT_NAME}-${name}"
      PRIVATE
      libxc::XC_Fortran
    )
  endif()

  if (${mpi_enabled} AND LIBGRIDXC_WITH_MPI)
    separate_arguments(MPIEXEC_PREFLAGS)
    add_test( NAME "libgridxc_mpi_${name}"
              COMMAND
                ${MPIEXEC_EXECUTABLE}
                ${MPIEXEC_NUMPROC_FLAG} "${num_ranks}"
                ${MPIEXEC_PREFLAGS}
		$<TARGET_FILE:${PROJECT_NAME}-${name}> ${MPIEXEC_POSTFLAGS})

  else()
  
    add_test(NAME "libgridxc_${name}" COMMAND $<TARGET_FILE:${PROJECT_NAME}-${name}> )
    
  endif()
  
endmacro()

define_test(test1 test1.f90 OFF)
define_test(test2 test2.F90 ON)
define_test(test3 test3.F90 ON)
define_test(test4 test4.F90 ON)
# test5 is pending refactoring
define_test(test6 test6.f90 OFF)
      
if (LIBGRIDXC_WITH_LIBXC)
  define_test(test_libxc test_libxc.F90 ON)
  define_test(test_libxc2 test_libxc2.F90 ON)
  define_test(test_match test_match.F90 OFF)
  define_test(test_hse06 test_hse06.F90 OFF)
endif()

=== config/CMakeLists.txt ===


# Set build type as CMake does not provide defaults
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(
    CMAKE_BUILD_TYPE "RelWithDebInfo"
    CACHE STRING "Build type to be used."
    FORCE
  )
  message(
    STATUS
    "Setting build type to '${CMAKE_BUILD_TYPE}' as none was specified."
  )
endif()

if (LIBGRIDXC_INSTALL)

  include(CMakePackageConfigHelpers)

  configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/template.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
    INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )

  # Use "AnyNewerVersion" but recommend checking for new features
  # (i.e. procedure pointers) at client's configuration time.
  # In this way we can request, say, a minimum version of 1.1.0, and
  # still be able to use 2.X if found.

  write_basic_package_version_file(
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
    VERSION "${PROJECT_VERSION}"
    COMPATIBILITY AnyNewerVersion
  )
  install(
    FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
  )

  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/template.pkgconf"
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    @ONLY
  )
  install(
    FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
  )

endif(LIBGRIDXC_INSTALL)

=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -12,10 +12,10 @@
   DOC "path to the ford executable (required to generate the documentation)"
   )
   
-if(FORD_EXE AND LIBGRIDXC_BUILD_DOCS_FORD)
+if(FORD_EXE)
 
   # for ford pre-processing
-  if(WITH_LIBXC)
+  if(LIBGRIDXC_WITH_LIBXC)
     set(INCLUDE_LIBXC "HAVE_LIBXC")
   else()
     set(INCLUDE_LIBXC "_DUMMY")
@@ -33,7 +33,11 @@
   WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
   VERBATIM
   )
- message(STATUS "Done generating documentation")
- 
-  install(DIRECTORY "${FORD_OUTPUT_DIR}/" DESTINATION ${CMAKE_INSTALL_PREFIX}/doc)
+ message(STATUS "Done generating documentation in ${FORD_OUTPUT_DIR}")
+
+  if(LIBGRIDXC_INSTALL)
+    message(STATUS "Installing documentation in ${CMAKE_INSTALL_PREFIX}/doc")
+    install(DIRECTORY "${FORD_OUTPUT_DIR}/" DESTINATION ${CMAKE_INSTALL_PREFIX}/doc)
+  endif()
+  
 endif()

=== debian/changelog ===
libgridxc (2.1.0-2) unstable; urgency=medium

  * debian/patches/fix_fortran_flags.patch: New patch, removed -march=native
    from Fortran flags. 

 -- Michael Banck <mbanck@debian.org>  Sun, 30 Mar 2025 13:54:54 +0200

libgridxc (2.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Mon, 10 Mar 2025 01:14:37 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Standards-Version: 4.1.3
 Homepage: https://gitlab.com/siesta-project/libraries/libgridxc
 Vcs-Browser: https://salsa.debian.org/debichem-team/libgridxc
-Vcs-Git: https://salsa.debian.org/debichem-team/ibgridxc.git
+Vcs-Git: https://salsa.debian.org/debichem-team/libgridxc.git
 
 Package: libgridxc-dev
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --                                    \
		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}                \
		-DWITH_LIBXC=YES

=== debian/watch ===
version=4
opts="searchmode=plain" \
 https://gitlab.com/siesta-project/libraries/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@

## libgridxc 2.1.0%2Breally2.0.2

=== debian/changelog ===
libgridxc (2.1.0+really2.0.2-1) unstable; urgency=medium

  * Roll back upstream to 2.0.2 release.
  * debian/patches/fix_fortran_flags.patch: Removed, no longer needed. 

 -- Michael Banck <mbanck@debian.org>  Thu, 04 Dec 2025 22:42:34 +0100
